VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsMulDecode"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Description = "Decode mul project by Fallout (roman3k@mail.ru)"
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

' ************************************* '
' *Create by Fallout (roman3k@mail.ru)* '
' *     Do not remove this header     * '
' ************************************* '
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Private Declare Function CreateCompatibleBitmap Lib "gdi32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
Private Declare Function CreateCompatibleDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function SelectObject Lib "gdi32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Private Declare Function DeleteDC Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Private Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hdc As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long

Private Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type

Private hDCTmp As Long
Private hBMTmp As Long
Private hBrush As Long

Private mOffset As Long
Private mSize As Long
Private mExtra As Long

Private X As Integer, Y As Integer
Private i As Integer
Private rowpos As Integer, rowend As Integer
Private incValue As Integer

Private colorTable(0 To &H3F4 - 1) As Integer

Private mvarFilePath As String
Private mvarFilePathIdx As String

Public Property Let FilePath(ByVal vData As String)
    mvarFilePath = vData
End Property

Public Property Get FilePath() As String
    FilePath = mvarFilePath
End Property

Public Property Get WidhtInfo() As Integer
    WidhtInfo = 44
End Property

Public Property Get HeightInfo() As Integer
    HeightInfo = 44
End Property

Public Property Let FilePathIdx(ByVal vData As String)
    mvarFilePathIdx = vData
End Property

Public Property Get FilePathIdx() As String
    FilePathIdx = mvarFilePathIdx
End Property

Private Sub Clear_Dc()
    DeleteDC hDCTmp                ' clean up '
    DeleteObject hBMTmp
End Sub

Public Sub DecodeFileInfo(ByRef picHdc As Long, ByVal infId As Long)
    Dim fileNum As Integer, R As RECT
    fileNum = FreeFile()           ' get freefile num '

    If hDCTmp <> 0 Then Clear_Dc   '
    Open mvarFilePathIdx For Binary Access Read As fileNum
    Get fileNum, infId * 12 + 1, mOffset
    Get fileNum, Seek(fileNum), mSize
    Get fileNum, Seek(fileNum), mExtra
    Close fileNum
    fileNum = FreeFile()
    Open mvarFilePath For Binary As fileNum
    Get fileNum, mOffset + 1, colorTable()   ' read color table '
    Close fileNum
    ' create memory pool '
    hDCTmp = CreateCompatibleDC(GetDC(0))               ' create a device context                   '
    hBMTmp = CreateCompatibleBitmap(GetDC(0), 44, 44)   ' create a bitmap                           '
    SelectObject hDCTmp, hBMTmp                         ' select the bitmap into the device context '
    SetRect R, 0, 0, 44, 44                             ' set the rectangle's values                '
    hBrush = CreateSolidBrush(vbGreen)                 '                                           '
    FillRect hDCTmp, R, hBrush                          ' fill the rect with the your color         '
    DeleteObject hBrush                                 ' delete our brush                          '
    ' end create '
    X = 0: Y = 0: rowpos = 21: rowend = 23: i = 0
    incValue = 1
    Do
        For X = rowpos To rowend - 1
            SetPixel hDCTmp, X, Y, Color16To32(colorTable(i))
            i = i + 1
        Next X
        If ((rowpos = 0) And (Y = 21)) Then
            rowpos = rowpos - 1
            rowend = rowend + 1
            incValue = -incValue
        End If
        rowpos = rowpos - incValue
        rowend = rowend + incValue
        Y = Y + 1
    Loop While i < 1012
    picHdc = hDCTmp
End Sub

Private Sub Class_Terminate()
    Clear_Dc
End Sub

Private Function Color16To32(color16 As Integer) As Long   '  16   32   '
    Color16To32 = RGB(((((color16 And &H7C00) / &H400) / &H1F) * &HFF), ((((color16 And &H3E0) / &H20) / &H1F) * &HFF), (((color16 And &H1F) / &H1F) * &HFF))
End Function
